#include "MyBox.h"

namespace tutorial {

	MyBox::MyBox(std::string id) : cg::Entity(id) {
	}
	MyBox::~MyBox() {
	}
	double MyBox::randomBetween(double min, double max) {
		return (rand() / (double)RAND_MAX * (max - min)) + min;
	}
	void MyBox::init() {
		// Read from property file
		double min_size = cg::Properties::instance()->getDouble("MIN_SIZE");
		double max_size = cg::Properties::instance()->getDouble("MAX_SIZE");
		// Creates box
		cg::tWindow win = cg::Manager::instance()->getApp()->getWindow();
		_winWidth = win.width;
		_winHeight = win.height;
		_position = cg::Vector2d(randomBetween(0,_winWidth),randomBetween(0,_winHeight));
		_size = cg::Vector2d(randomBetween(min_size,max_size),randomBetween(min_size,max_size));
		_color = cg::Vector3d(randomBetween(0.1,0.9),randomBetween(0.1,0.9),randomBetween(0.1,0.9));
		// Sends a message to debug file
		std::ofstream& file = cg::DebugFile::instance()->getOutputFileStream();
		file << "Created a box with size " << _size << "." << std::endl;
	}
}